message(STATUS "[INFO] Installing aff3ct")

add_git_submodule(${CMAKE_CURRENT_SOURCE_DIR}/third-party/aff3ct)

set(AFF3CT_COMPILE_EXE OFF)
set(AFF3CT_COMPILE_STATIC_LIB ON)
set(AFF3CT_POLAR_BIT_PACKING OFF)
set(AFF3CT_COLORS OFF)
set(AFF3CT_PREC 32)

execute_process(
  COMMAND
    ${CMAKE_COMMAND} -S${CMAKE_CURRENT_SOURCE_DIR}/third-party/aff3ct
    -B${AFF3CT_BUILD_DIR_FULL}/ -DCMAKE_BUILD_TYPE=${AFF3CT_BUILD_TYPE}
    -DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}
    -DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
    -DCMAKE_INSTALL_PREFIX=${AFF3CT_BUILD_DIR_FULL}/install
    -DCMAKE_WINDOWS_EXPORT_ALL_SYMBOLS=TRUE
    -DCMAKE_C_COMPILER:STRING=${CMAKE_C_COMPILER}
    -DCMAKE_CXX_COMPILER:STRING=${CMAKE_CXX_COMPILER}
    -DCMAKE_GENERATOR=${CMAKE_GENERATOR}
    -DAFF3CT_COMPILE_EXE=${AFF3CT_COMPILE_EXE}
    -DAFF3CT_COMPILE_STATIC_LIB=${AFF3CT_COMPILE_STATIC_LIB}
    -DAFF3CT_POLAR_BIT_PACKING=${AFF3CT_POLAR_BIT_PACKING}
    -DAFF3CT_PREC=${AFF3CT_PREC} -DAFF3CT_COLORS=${AFF3CT_COLORS} COMMAND_ECHO
    STDOUT COMMAND_ERROR_IS_FATAL ANY)

execute_process(
  COMMAND
    ${CMAKE_COMMAND} --build ${AFF3CT_BUILD_DIR_FULL} -j 8 --target
    aff3ct-static-lib install COMMAND_ECHO STDOUT COMMAND_ERROR_IS_FATAL ANY)
